"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _reactNativeWebview = _interopRequireWildcard(require("react-native-webview"));
var _iFrame = require("./iFrame");
var _assets = require("./assets");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
/* eslint-disable prettier/prettier */

const YoutubePlayer = _ref => {
  let {
    videoId
  } = _ref;
  const webRef = (0, _react.useRef)(null);
  const [time, setTime] = (0, _react.useState)('00:00');
  const [loading, setLoading] = (0, _react.useState)(true);
  const [playing, setPlaying] = (0, _react.useState)(false);
  const [currentSecond, setCurrentSecond] = (0, _react.useState)(0);
  const [webViewHasLoadedContent, setWebViewHasLoadedContent] = (0, _react.useState)(false);
  const playVideo = () => {
    var _webRef$current;
    setPlaying(true);
    (_webRef$current = webRef.current) === null || _webRef$current === void 0 ? void 0 : _webRef$current.injectJavaScript('play()');
  };
  const pauseVideo = () => {
    var _webRef$current2;
    setPlaying(false);
    (_webRef$current2 = webRef.current) === null || _webRef$current2 === void 0 ? void 0 : _webRef$current2.injectJavaScript('pause()');
  };
  const seekForwardTo = () => {
    var _webRef$current3;
    let forwardSeek = currentSecond + 10;
    (_webRef$current3 = webRef.current) === null || _webRef$current3 === void 0 ? void 0 : _webRef$current3.injectJavaScript(`seekTo(${forwardSeek})`);
  };
  const seekBackTo = () => {
    var _webRef$current4;
    let backSeek = currentSecond - 10;
    (_webRef$current4 = webRef.current) === null || _webRef$current4 === void 0 ? void 0 : _webRef$current4.injectJavaScript(`seekTo(${backSeek})`);
  };
  const restartVideo = () => {
    var _webRef$current5;
    (_webRef$current5 = webRef.current) === null || _webRef$current5 === void 0 ? void 0 : _webRef$current5.injectJavaScript('seekTo(0)');
  };
  const onMessageRecieved = message => {
    const responseJSON = JSON.parse(message.nativeEvent.data);
    const minutes = Math.round(responseJSON.currentDuration / 60);
    const seconds = Math.round(responseJSON.currentDuration % 60);
    const minutesText = minutes < 10 ? `0${minutes}` : minutes;
    const secondsText = seconds < 10 ? `0${seconds}` : seconds;
    setCurrentSecond(seconds);
    setTime(`${minutesText}:${secondsText}`);
  };
  return /*#__PURE__*/_react.default.createElement(_reactNative.SafeAreaView, {
    style: styles.container
  }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: styles.videoContainer
  }, /*#__PURE__*/_react.default.createElement(_reactNativeWebview.default, {
    ref: webRef,
    source: {
      html: (0, _iFrame.buildHTML)(videoId)
    },
    allowsFullscreenVideo: false,
    allowsInlineMediaPlayback: true,
    scalesPageToFit: false,
    onMessage: onMessageRecieved,
    mediaPlaybackRequiresUserAction: false,
    startInLoadingState: true,
    onLoad: () => setLoading(false),
    renderLoading: () => /*#__PURE__*/_react.default.createElement(_reactNative.ActivityIndicator, {
      size: "large",
      color: 'white',
      style: {
        position: 'absolute',
        alignSelf: 'center',
        marginTop: 95
      }
    }),
    onLoadStart: event => {
      setTimeout(() => {
        setWebViewHasLoadedContent(true);
      }, 500);
    },
    style: {
      opacity: webViewHasLoadedContent ? 1 : 0
    }
  }), loading ? null : /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: {
      height: '100%',
      width: '100%',
      position: 'absolute',
      opacity: 0.1
    }
  })), /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: styles.buttonRow
  }, /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
    style: {
      marginHorizontal: 10
    },
    activeOpacity: 1,
    onPress: seekBackTo
  }, /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
    source: _assets.Images.back,
    style: {
      height: 30,
      width: 30
    },
    resizeMode: "contain"
  })), !playing ? /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
    activeOpacity: 1,
    onPress: playVideo
  }, /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
    source: _assets.Images.play,
    style: {
      height: 50,
      width: 49
    }
  })) : /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
    activeOpacity: 1,
    onPress: pauseVideo
  }, /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
    source: _assets.Images.pause,
    style: {
      height: 50,
      width: 49
    },
    resizeMode: "contain"
  })), /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
    style: {
      marginHorizontal: 10
    },
    activeOpacity: 1,
    onPress: seekForwardTo
  }, /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
    source: _assets.Images.next,
    s: true,
    style: {
      height: 30,
      width: 30
    },
    resizeMode: "contain"
  })), /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: styles.textContainer
  }, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: styles.timeLabel
  }, time))));
};
const styles = _reactNative.StyleSheet.create({
  container: {
    ..._reactNative.StyleSheet.absoluteFillObject
  },
  videoContainer: {
    height: 200,
    backgroundColor: 'transparent'
  },
  buttonContainer: {
    flexDirection: 'row',
    width: '100%',
    justifyContent: 'space-around'
  },
  buttonRow: {
    height: 80,
    flexDirection: 'row',
    alignItems: 'center',
    justifyContent: 'center',
    borderTopLeftRadius: 20,
    borderTopRightRadius: 20,
    backgroundColor: 'white'
  },
  textContainer: {
    justifyContent: 'center',
    alignItems: 'center'
  },
  timeLabel: {
    fontWeight: 'bold',
    fontSize: 20
  }
});
var _default = YoutubePlayer;
exports.default = _default;
//# sourceMappingURL=YoutubePlayer.js.map